/*
   Basic sector scrambler - spath 05/02
                                        */
#include <stdio.h>
#include <stdlib.h>

int ShiftRegister = 0x0001;
int Sector[2352];

void UpdateShiftRegister()
{
  int i;
  for(i=0;i<8;i++)
  {
    int hibit = ((ShiftRegister & 1)^((ShiftRegister & 2)>>1)) << 15;
    ShiftRegister = (hibit | ShiftRegister) >> 1;
  }
}

void Scramble()
{
  int i;
  for (i=12;i<2352;i++)
  {
    Sector[i] = Sector[i] ^ (ShiftRegister&0xFF);
    UpdateShiftRegister();
  }
}

void LoadSector(char* InputFile)
{
  int i;
  FILE *fd;
  unsigned char c;

  fd = fopen(InputFile,"rb");
  for (i=0;i<2352;i++) {
     fscanf(fd,"%c",&c);
     Sector[i]=c;
  }
}

void DisplaySector()
{
  int i;
  for (i=0;i<2352;i++){
    if ((i+1)%10 !=0) printf ("%02X ",Sector[i]);
    else printf ("%02X\n",Sector[i]);
    }
}


int main (int argc, char **argv)
{
  LoadSector(argv[1]);
  Scramble();
  DisplaySector();
}

