#include "bm_load.h"

///////////////////////////////////////////////////////////////////////////////
//   Macros

#define GS_BGCOLOUR	*((volatile unsigned long int*)0x120000E0)

///////////////////////////////////////////////////////////////////////////////
//   Globals

u32 errorColour[] = {	0x000000,	// Dummy
						0x0000ff,	// ERROR_LOADELF_FILEIO, red
						0x00ffff,	// ERROR_LOADELF_ELF, yellow
						0xff0000,	// ERROR_LOADELF_MEMORY, blue
						0x00ff00,	// ERROR_LOADELF_OVERWRITE, green
						0xffff00	// ERROR_ARGS, agua


};


int entryPoint;

///////////////////////////////////////////////////////////////////////////////
//   Function declarations

int loadModules();
static void error(int errno);

///////////////////////////////////////////////////////////////////////////////
//   Function defenitions

int main(int argc, char **argv)
{
	int retVal;
	int newArgc;
	char **newArgv;

	// Initialise
	SifInitRpc(0);
	SifResetIop();
	SifInitRpc(0);

	if(argc < 1) error(ERROR_ARGS);

	if(argc > 1) {
		newArgc = argc - 1;
		newArgv = &argv[1];
	}
	else {
		newArgc = 0;
		newArgv = NULL;
	}

	// Load required IRX modules
	loadModules();
		
	// Load the game elf into memory
	if((retVal = loadElf(argv[0], &entryPoint)) < 0)
		error(retVal);

	// Shutdown
	SifCmdExit();

	// Start execution of the game elf
	ExecPS2((void *)entryPoint, (void *)0, newArgc, newArgv);

	// Should never get here
	SleepThread();
}

int loadModules()
{
	SifLoadModule("rom0:SIO2MAN", 0, NULL);

	return 0;
}

static void error(int errno)
{
	errno *= -1;

	GS_BGCOLOUR = errorColour[errno];
	while(1);
}
