#ifndef _BM_LOAD_H
#define _BM_LOAD_H

#include <tamtypes.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <kernel.h>
#include <sifrpc.h>
#include <fileio.h>
#include <iopcontrol.h>
#include <loadfile.h>

#include "loadelf.h"

///////////////////////////////////////////////////////////////////////////////
//   Error macros

#define ERROR_LOADELF_FILEIO	-1
#define ERROR_LOADELF_ELF		-2
#define ERROR_LOADELF_MEMORY	-3
#define ERROR_LOADELF_OVERWRITE	-4
#define ERROR_ARGS				-5

///////////////////////////////////////////////////////////////////////////////
//   Function declarations

// From asm.s
void setSyscall(int number, void (*functionPtr)(void));
void jumpEntryPoint(void *entryPoint);
void enterKernelMode();
void enterUserMode();
void *findSyscallTable();
void installAccelerator(int *syscallTable, int vid_mode);
int k_readMem(void *address);					// Not used, not needed

///////////////////////////////////////////////////////////////////////////////
//   Globals

extern int __start __attribute__((section(".data")));	// start of program segment in ram
extern int _stack_end __attribute__((section(".data")));		// end of program segment in ram

#endif