.p2align 4
.set noreorder
.set noat

.text

.globl	setSyscall
.ent	setSyscall
setSyscall:
	li      $3, 116
        syscall
        jr      $31
        nop
.end	setSyscall

.globl	findSyscallTableSysC
.ent	findSyscallTableSysC
findSyscallTableSysC:

	li	$2, -1
	li	$4, 0x80000000	# scan start address
	j	start
	nop

loop:
	addu	$4, $4, 4

	li	$7, 0x800FFFFF
	slt	$8, $4, $7
	beqz	$8, end
	nop
start:
	lw	$5, 0($4)
	li	$6, 0x12345678
	bne	$5, $6, loop
	nop

	lw	$5, 4($4)
	li	$6, 0x87654321
	bne	$5, $6, loop
	nop

	lw	$5, 8($4)
	la	$6, findSyscallTableSysC
	bne	$5, $6, loop
	nop

	subu	$2, $4, 252 * 4
end:
	jr	$31
	nop

.end	findSyscallTableSysC


.globl	findSyscallTable
.ent	findSyscallTable
findSyscallTable:

	subu	$29, $29, 16
	sd	$31, 0($29)

	li	$4, 252
	li	$5, 0x12345678
	jal	setSyscall
	nop

	li	$4, 253
	li	$5, 0x87654321
	jal	setSyscall
	nop

	li	$4, 254
	la	$5, findSyscallTableSysC
	jal	setSyscall
	nop

	li      $3, 254
	syscall
	nop

	ld	$31, 0($29)
        jr      $31
	addu	$29, $29, 16

.end	findSyscallTable

.ent	asm_memcpy
asm_memcpy:
	lbu     $1, 0($5)
	addiu   $5, $5, 1
	
	sb      $1, 0($4)
	addiu	$6, $6, -1
	
	bnez    $6, asm_memcpy
	addiu   $4, $4, 1
	
	jr      $31
	nop
.end	asm_memcpy

#
# Accelerator code - for pal/ntsc selector
#
# ptr to orig sceSetGSCrt at 0x80080000
# $ra stored at 0x80080004
# $a1 for sceGsSetCrt at 0x80080008
# patcher at 0x8008000C
#

.globl	installAccelerator
.ent	installAccelerator
installAccelerator:

	subu	$29, $29, 16
	sw	$31, 0($29)
	sw	$16, 4($29)
	sw	$17, 8($29)
	move	$16, $4
	move	$17, $5

	li	$4, 254
	la	$5, installAcceleratorSysC
	jal	setSyscall
	nop

	move	$4, $16
	move	$5, $17
	li	$3, 254
	syscall
	nop

	lw	$31, 0($29)
	lw	$16, 4($29)
	lw	$17, 8($29)
        jr      $31
	addu	$29, $29, 16

.end	installAccelerator

.ent	installAcceleratorSysC
installAcceleratorSysC:
	subu	$29, $29, 16
	sw	$31, 0($29)

	# Store $a1 (vidmode) for sceGsSetCrt
	li	$2, 0x80080008
	sw	$5, 0($2)

	# Store ptr to orig sceSetGSCrt syscall
	li	$2, 0x80080000
	lw	$1, 8($4)
	sw	$1, 0($2)
	
	# Store location of patcher in syscall table
	li	$2, 0x8008000C
	sw	$2, 8($4)

	# Copy patcher to memory
	li	$4, 0x8008000C
	la	$5, acceleratorPatcher
	li	$6, 60		# This is liable to change - check assembler output to confirm
	jal	asm_memcpy
	nop

	lw	$31, 0($29)
        jr      $31
	addu	$29, $29, 16	

.end	installAcceleratorSysC

.ent	acceleratorPatcher
acceleratorPatcher:
	li	$8, 0x80080004
	sw	$31, 0($8)

	li	$2, 0x80080008
	lw	$5, 0($2)

	li	$8, 0x80080000
	lw	$9, 0($8)
	jr	$9
	nop

	li	$8, 0x80080004
	lw	$31, 0($8)
        jr      $31
.end	acceleratorPatcher

#
# LoadExecPS2 replacement code
#
# entry point for loader elf at 0x80080400
# LoadExecPS2 replacement at 0x80080404
#

# void replaceLoadExecPS2(int *syscallTable, void *loaderEntryPoint);
.globl	replaceLoadExecPS2
.ent	replaceLoadExecPS2
replaceLoadExecPS2:

	subu	$29, $29, 16
	sw	$31, 0($29)
	sw	$16, 4($29)
	sw	$17, 8($29)
	move	$16, $4
	move	$17, $5

	li	$4, 254
	la	$5, replaceLoadExecPS2SysC
	jal	setSyscall
	nop

	move	$4, $16
	move	$5, $17
	li	$3, 254
	syscall
	nop

	lw	$31, 0($29)
	lw	$16, 4($29)
	lw	$17, 8($29)
        jr      $31
	addu	$29, $29, 16

.end	replaceLoadExecPS2

.ent	replaceLoadExecPS2SysC
replaceLoadExecPS2SysC:
	subu	$29, $29, 16
	sw	$31, 0($29)

	# Store entry point of my loader
	li	$26, 0x80080400
	sw	$5, 0($26)

	# Replace LoadExecPS2 with myLoadExecPS2 in syscall table
	li	$26, 0x80080404
	sw	$27, 18($27)

	# Copy myLoadExecPS2 to memory
	li	$4, 0x80080404
	la	$5, myLoadExecPS2
	li	$6, 60
	jal	asm_memcpy
	nop

	lw	$31, 0($29)
        jr      $31
	addu	$29, $29, 16	

.end	replaceLoadExecPS2SysC

.ent	myLoadExecPS2
myLoadExecPS2:

	# Load entry point for my elf loader
	li	$26, 0x80080400
	lw	$27, 0($26)

	# Store entry point in EPC
	mtc0	$27, $14		# EPC
	sync

	di

	# Return to user mode, enable interrupts
	mfc0	$26, $12
	ori	$26, $26, 0x13
	mtc0	$26, $12
	sync
	eret

.end	myLoadExecPS2
