#ifndef _BOOTMASTER_H
#define _BOOTMASTER_H

#include <tamtypes.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <kernel.h>
#include <sifrpc.h>
#include <iopcontrol.h>
#include <loadfile.h>
#include <fileio.h>
#include <libpad.h>

#include "sjgfx.h"
#include "libpad.h"
#include "cdvdfsv.h"
#include "hax0r.h"

///////////////////////////////////////////////////////////////////////////////
//   Error macros

#define ERROR_HAX0R				-4
#define ERROR_CDVDFSV_INIT		-5
#define ERROR_SYSTEMCNF_PARSE	-6
#define ERROR_SYSTEMCNF_FILEIO	-7
#define ERROR_SYSTEMCNF_MEMORY	-8

///////////////////////////////////////////////////////////////////////////////
//   Function declarations

void *decompressLoader();

///////////////////////////////////////////////////////////////////////////////
//   Globals

extern int __start __attribute__((section(".data")));	// start of program segment in ram
extern int _end __attribute__((section(".data")));		// end of program segment in ram

#endif