#ifndef _HAX0R_H
#define _HAX0R_H

#define IOP_MEM_BASE	0xBC000000
#define IOP_MEM_SIZE	0x200000	// 2MB

#define _RESIDENT_	__attribute__((section(".resident")))

#define MAKE_ORI(rt, rs, imm) (u32)((0x0D << 26) | (rs << 21) | (rt << 16) | (imm))
#define MAKE_J(func) (u32)( (0x02 << 26) | (((u32)func) / 4) )
#define JR_RA	0x03E00008
#define NOP		0x00000000

/////////////////////////////////////////////////////////////////////////////////////
//   Resident global variables

extern int *syscallTable _RESIDENT_;

/////////////////////////////////////////////////////////////////////////////////////
//   Function declarations

int initHax0r();

void setSyscall(int number, void (*functionPtr)(void));
void *getSyscall(int number);							
void *findSyscallTable();								
void *execAsSyscall(void *(*functionPtr)(int arg1, int arg2),
					int arg1, int arg2);
					
int disableClearUserMem();
void setDataAddressWriteBreakpoint(void *address, int mask);

void installPNSelector(int vid_mode);					
void installIopRebootHandler(void (*functionPtr)(void));
void installDebugExceptionHandler(void (*functionPtr)(void));
void installMyLoadExecPS2(void *entryPoint);

/////////////////////////////////////////////////////////////////////////////////////
//   Resident function declarations

void set_kmode() _RESIDENT_;
void set_umode() _RESIDENT_;

#endif
