#include "mipsregs.h"

.p2align 4
.set noreorder
.set noat

#####################################################
# .resident section
#####################################################

.section .resident, "a"

dummy:	.word 0

.globl	umSifSetRegWatcher
.ent	umSifSetRegWatcher
umSifSetRegWatcher:

	# patch epc
	la v1, SifSetRegWatcher
	sw v1, 8(sp)

	jr ra
	nop
.end	umSifSetRegWatcher


.globl	oldSifSetReg
.ent	oldSifSetReg
oldSifSetReg:
	li	v1, 251
	syscall
	jr	ra
	nop
.end	oldSifSetReg

.ent	invalidateICache
invalidateICache:
	li      k0, 0
invalidateLoop:
	sync
	cache 7, 0(k0)  # Index Load Tag (secondary data cache)
	cache 7, 1(k0)  # Index Load Tag (secondary data cache)
	sync
	addiu k0, 0x40
	slti k1, k0, 0x2000
	bnez k1, invalidateLoop
	nop
	cache 0xC, 0(zero)  # Create Dirty Exclusive (primary instruction cache)
	sync
	jr	ra
	nop
.end	invalidateICache


.p2align 4	# align 16 bytes (IMPORTIANT!!!)
yposRegisterContect:	.space	0x200
bgcol_val:		.word 0x0000ff






.globl	yposHandler
.ent	yposHandler
yposHandler:

	# save registers
	sq      k0, -0x30(zero)
	sq      k1, -0x40(zero)

	la	k0, yposRegisterContect
	sq	$1, 0x10(k0)
	sq	$2, 0x20(k0)
	sq	$3, 0x30(k0)
	sq	$4, 0x40(k0)
	sq	$5, 0x50(k0)
	sq	$6, 0x60(k0)
	sq	$7, 0x70(k0)
	sq	$8, 0x80(k0)
	sq	$9, 0x90(k0)
	sq	$10, 0xA0(k0)
	sq	$11, 0xB0(k0)
	sq	$12, 0xC0(k0)
	sq	$13, 0xD0(k0)
	sq	$14, 0xE0(k0)
	sq	$15, 0xF0(k0)
	sq	$16, 0x100(k0)
	sq	$17, 0x110(k0)
	sq	$18, 0x120(k0)
	sq	$19, 0x130(k0)
	sq	$20, 0x140(k0)
	sq	$21, 0x150(k0)
	sq	$22, 0x160(k0)
	sq	$23, 0x170(k0)
	sq	$24, 0x180(k0)
	sq	$25, 0x190(k0)
	sq	$28, 0x1C0(k0)
	sq	$29, 0x1D0(k0)
	sq	$30, 0x1E0(k0)
	sq	$31, 0x1F0(k0)

	# t0 = insn at ErrorEPC
	# t1 = rt
	# t2 = value in rt
	# t3 = base
	# t4 = address
	# t5 = address holding rt within array
	# t6 = address holding base within array
	# t7 = new value for rt

	# decode insn, get rt and write address
	mfc0	k0, $30
	lw	t0, 0(k0)

	srl	t1, t0, 16
	andi	t1, t1, 0x1f

	srl	t3, t0, 21	
	andi	t3, t3, 0x1f

	# get value from base from within saved register array
	sll	k0, t3, 4		# k0 = base * 16
	la	t6, yposRegisterContect
	addu	t6, t6, k0		# t6 = &yposRegisterContect[base]; (if type = u128)

	lw	t4, 0(t6)
	li	k0, 0xffff
	and	k1, t0, k0
	addu	t4, t4, k1		# t4 = address which triggered breakpoint

	# get value from rt from within saved register array
	sll	k0, t1, 4		# k0 = rt * 16
	la	t5, yposRegisterContect
	addu	t5, t5, k0		# t5 = &yposRegisterContect[rt];

	lq	t2, 0(t5)		# t2 = value in rt
	
	# check if display is high or low res
	dsrl	k0, t2, 44
	andi	k0, k0, 0x7FF
	slti	k1, k0, 257		# if(display_height < 257) set k1 = 1
	beqz	k1, highRes
	nop

	# low res
	la	k0, ydiffLowRes
	lw	a0, 0(k0)		# a0 = y offset (signed)

	j	1f
	nop

highRes:
	la	k0, ydiffHighRes
	lw	a0, 0(k0)		# a0 = y offset (signed)

1:

	srl	a1, t2, 12
	andi	a1, a1, 0x7FF		
	addu	a1, a1, a0		# a1 = orig-y + offset

	bgez	a1, 1f
	nop

	move	a1, zero
1:

	li	k0, 0xFF800FFF
	and	k0, t2, k0
	sll	a1, a1, 12
	or	t7, k0, a1


	# store modified value
	sq	t7, 0(t4)


	# restore registers
	la	k0, yposRegisterContect
	lq	$1, 0x10(k0)
	lq	$2, 0x20(k0)
	lq	$3, 0x30(k0)
	lq	$4, 0x40(k0)
	lq	$5, 0x50(k0)
	lq	$6, 0x60(k0)
	lq	$7, 0x70(k0)
	lq	$8, 0x80(k0)
	lq	$9, 0x90(k0)
	lq	$10, 0xA0(k0)
	lq	$11, 0xB0(k0)
	lq	$12, 0xC0(k0)
	lq	$13, 0xD0(k0)
	lq	$14, 0xE0(k0)
	lq	$15, 0xF0(k0)
	lq	$16, 0x100(k0)
	lq	$17, 0x110(k0)
	lq	$18, 0x120(k0)
	lq	$19, 0x130(k0)
	lq	$20, 0x140(k0)
	lq	$21, 0x150(k0)
	lq	$22, 0x160(k0)
	lq	$23, 0x170(k0)
	lq	$24, 0x180(k0)
	lq	$25, 0x190(k0)
	lq	$28, 0x1C0(k0)
	lq	$29, 0x1D0(k0)
	lq	$30, 0x1E0(k0)
	lq	$31, 0x1F0(k0)

	# incriment ErrorEPC
	mfc0	k0, $30			# ErrorEPC
	addiu	k0, k0, 4
	mtc0	k0, $30
	sync

	# set user mode, interrupts on
	mfc0	k0, $12
	ori	k0, k0, 0x11
	mtc0	k0, $12
	sync

	lq      k0, -0x30(zero)
	lq      k1, -0x40(zero)
	sync

	# return from exception
	eret

.end	yposHandler

#####################################################
# .text section
#####################################################

.text

#####################################################
## Misc functions

#
# void setSyscall(int number, void (*functionPtr)(void));
#
.globl	setSyscall
.ent	setSyscall
setSyscall:
	li      v1, 116
        syscall
        jr      ra
        nop
.end	setSyscall

#
# void *execAsSyscall(void *(*functionPtr)(int arg1, int arg2), int arg1, int arg2);
#
.globl	execAsSyscall
.ent	execAsSyscall
execAsSyscall:
	addiu	sp, sp, -32
	sw	ra, 0(sp)
	sw	s0, 4(sp)
	sw	s1, 8(sp)
	sw	s2, 12(sp)
	move	s0, a0
	move	s1, a1
	move	s2, a2

	# install as syscall
	li	a0, 255
	move	a1, s0
	jal	setSyscall
	nop

	# trigger syscall, executing function
	move	a0, s1
	move	a1, s2
	li	v1, 255
	sync
	syscall
	nop

	lw	s2, 12(sp)
	lw	s1, 8(sp)
	lw	s0, 4(sp)
	lw	ra, 0(sp)
	jr	ra
	addiu	sp, 32

.end	execAsSyscall

#####################################################
## Debug exception handler/breakpoint code

/*
#
# void installDebugExceptionHandler(void *handler);
#
.globl	installDebugExceptionHandler
.ent	installDebugExceptionHandler
installDebugExceptionHandler:

	subu	sp, sp, 16
	sw	ra, 0(sp)
	sw	s0, 4(sp)
	srl	s0, a0, 2
	
	li	a0, 254
	la	a1, installDebugExceptionHandlerSysC
	jal	setSyscall
	nop

	move	a0, s0
	li	v1, 254
	syscall
	nop

	lw	ra, 0(sp)
	lw	s0, 4(sp)
	jr      ra
	addu	sp, sp, 16

.end	installDebugExceptionHandler

.ent	installDebugExceptionHandlerSysC
installDebugExceptionHandlerSysC:

	sync

	li	k0, 0x80000100

	li	k1, 0x8000000	# j XXXX insn
	or	k1, k1, a0
	sw	k1, 0(k0)

	jr	ra
	nop

.end	installDebugExceptionHandlerSysC
*/

#
# void setDataAddressBreakpoint(void *address);
#
.globl	setDataAddressWriteBreakpoint
.ent	setDataAddressWriteBreakpoint
setDataAddressWriteBreakpoint:

	di

	sync.l

	li	k0, 0x8000
	mtbpc	k0			# All breakpoints off (BED = 1)

	sync.p

	mtdab	a0
	mtdabm	a1

	sync.p

	mfbpc	k1
	sync.p

	li	k0, 0x20200000		# Data write breakpoint on (DWE, DUE = 1)
	or	k1, k1, k0
	xori	k1, k1, 0x8000		# DEBUG exception trigger on (BED = 0)
	mtbpc	k1

	sync.p

	ei

	jr	ra
	nop

.end	setDataAddressWriteBreakpoint
